import { Context, Middleware } from 'serverless-compose';
import { APIGatewayProxyEvent, APIGatewayProxyResult } from 'aws-lambda';
export declare type RequestIdentifierContextMixin = {
    requestIdentity: RequestIdentifierContext;
};
export declare type RequestIdentifierContext = {
    correlationId: string;
    parentId?: string;
    requestId: string;
    sessionId: string;
    spanId: string;
    traceId: string;
};
export declare function bytesToUuid(bytes: Array<number>): string;
export declare function bytesToHexString(bytes: Array<number>): string;
export declare function formatHexAsUUID(hexString: string): string;
export declare function convertMaybeUuidToHexString(uuid?: string): string | void;
export declare function convertMaybeHexStringToUuid(hexString?: string): string | void;
export declare const DefaultAPIGatewayProxyRequestIdentifyingMiddleware: Middleware<APIGatewayProxyEvent, APIGatewayProxyResult, Context, APIGatewayProxyEvent, APIGatewayProxyResult, Context & RequestIdentifierContextMixin>;
