"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const v4_1 = __importDefault(require("uuid/v4"));
const byteToHex = [];
for (var i = 0; i < 256; ++i) {
    byteToHex[i] = (i + 0x100).toString(16).substr(1);
}
function bytesToUuid(bytes) {
    const hexString = bytesToHexString(bytes);
    return formatHexAsUUID(hexString);
}
exports.bytesToUuid = bytesToUuid;
function bytesToHexString(bytes) {
    return bytes.map(byte => byteToHex[byte]).join('');
}
exports.bytesToHexString = bytesToHexString;
function formatHexAsUUID(hexString) {
    return [
        hexString.slice(0, 8),
        '-',
        hexString.slice(8, 12),
        '-',
        hexString.slice(12, 16),
        '-',
        hexString.slice(16, 24),
        '-',
        hexString.slice(24, 36),
    ].join('');
}
exports.formatHexAsUUID = formatHexAsUUID;
function convertMaybeUuidToHexString(uuid) {
    if (uuid === undefined || uuid === null || uuid === '') {
        return;
    }
    // FIXME: handle case where it's not a UUID
    return uuid.replace('-', '');
}
exports.convertMaybeUuidToHexString = convertMaybeUuidToHexString;
function convertMaybeHexStringToUuid(hexString) {
    if (hexString === undefined || hexString === null || hexString === '') {
        return;
    }
    // FIXME: handle case where its not a Hex string suitable for a UUID
    return formatHexAsUUID(hexString);
}
exports.convertMaybeHexStringToUuid = convertMaybeHexStringToUuid;
// I hate this name too. Sorry.
exports.DefaultAPIGatewayProxyRequestIdentifyingMiddleware = (next) => async (event, context) => {
    const trace = new Array(16);
    v4_1.default(null, trace);
    const span = new Array(16);
    v4_1.default(null, span);
    const correlationId = event.headers['correlation-id'] || event.headers['x-correlation-id'];
    const parentId = event.headers['parent-id'] ||
        event.headers['x-parent-id'] ||
        event.headers['x-b3-parentspanid'];
    const requestId = event.headers['request-id'] || event.headers['x-request-id'];
    const sessionId = event.headers['session-id'] || event.headers['x-session-id'];
    const spanId = event.headers['span-id'] ||
        event.headers['x-span-id'] ||
        event.headers['x-b3-spanid'];
    const traceId = event.headers['trace-id'] ||
        event.headers['x-trace-id'] ||
        event.headers['x-b3-traceid'];
    const requestIdentifierContext = Object.assign({ correlationId: correlationId ||
            convertMaybeHexStringToUuid(traceId) ||
            bytesToUuid(trace) }, (parentId && { parentId }), { requestId: requestId ||
            correlationId ||
            convertMaybeHexStringToUuid(traceId) ||
            bytesToUuid(trace), sessionId: sessionId ||
            correlationId ||
            convertMaybeHexStringToUuid(traceId) ||
            bytesToUuid(trace), spanId: spanId || bytesToHexString(span.slice(0, 8)), traceId: traceId ||
            convertMaybeUuidToHexString(correlationId) ||
            bytesToHexString(trace) });
    const result = await next(event, Object.assign({}, context, { requestIdentity: requestIdentifierContext }));
    const headers = {
        'correlation-id': requestIdentifierContext.correlationId,
        'x-correlation-id': requestIdentifierContext.correlationId,
        'parent-id': requestIdentifierContext.parentId,
        'x-parent-id': requestIdentifierContext.parentId,
        'x-b3-parentspanid': requestIdentifierContext.parentId,
        'request-id': requestIdentifierContext.requestId,
        'x-request-id': requestIdentifierContext.requestId,
        'session-id': requestIdentifierContext.sessionId,
        'x-session-id': requestIdentifierContext.sessionId,
        'span-id': requestIdentifierContext.spanId,
        'x-span-id': requestIdentifierContext.spanId,
        'x-b3-spanid': requestIdentifierContext.spanId,
        'trace-id': requestIdentifierContext.traceId,
        'x-trace-id': requestIdentifierContext.traceId,
        'x-b3-traceid': requestIdentifierContext.traceId,
    };
    return Object.assign({}, result, { headers: Object.assign({}, (result.headers || {}), headers) });
};
//# sourceMappingURL=middleware.js.map